unit Autostart;

interface

type
  TAutostart = class(TObject)
  public
    class procedure Add;
    class procedure Remove;
    class function OnList : Boolean;
  end;


implementation

uses
  Classes, Registry, ActiveX, SysUtils, Forms, Windows;

const
  RegKey = 'SOFTWARE\Microsoft\Windows CE Services\AutoStartOnConnect';

class procedure TAutostart.Add;
  var
    Registry     : TRegistry;
    Applications : TStringList;
    NewGuid      : TGuid;
    i            : Integer;
begin
  Registry     := TRegistry.Create;
  Applications := TStringList.Create;

  try
    Registry.RootKey := HKEY_LOCAL_MACHINE;

    if Registry.OpenKey(RegKey,false) then begin
      Registry.GetValueNames(Applications);  // All GUIDs

      for i := 0 to Applications.Count - 1 do begin
        if Registry.ReadString(Applications[i]) = Application.ExeName then begin
          // Application already on the list
          Exit;
        end;
      end;

      // Have not yet added this application to the list
      CoCreateGuid(NewGuid);
      Registry.WriteString(GuidToString(NewGuid),Application.ExeName);
    end;
  finally
    Applications.Free;
    Registry.Free;
  end;
end;

class procedure TAutostart.Remove;
  var
    Registry     : TRegistry;
    Applications : TStringList;
    i            : Integer;
begin
  Registry     := TRegistry.Create;
  Applications := TStringList.Create;

  try
    Registry.RootKey := HKEY_LOCAL_MACHINE;

    if Registry.OpenKey(RegKey,false) then begin
      Registry.GetValueNames(Applications);  // All GUIDs

      for i := 0 to Applications.Count - 1 do begin
        if Registry.ReadString(Applications[i]) = Application.ExeName then begin
          Registry.DeleteValue(Applications[i]);
        end;
      end;
    end;
  finally
    Applications.Free;
    Registry.Free;
  end;
end;

class function TAutostart.OnList : Boolean;
  var
    Registry     : TRegistry;
    Applications : TStringList;
    NewGuid      : TGuid;
    i            : Integer;
begin
  Registry     := TRegistry.Create;
  Applications := TStringList.Create;
  Result := False;

  try
    Registry.RootKey := HKEY_LOCAL_MACHINE;

    if Registry.OpenKey(RegKey,false) then begin
      Registry.GetValueNames(Applications);  // All GUIDs

      for i := 0 to Applications.Count - 1 do begin
        if Registry.ReadString(Applications[i]) = Application.ExeName then begin
          Result := True;
          Exit;
        end;
      end;
    end;
  finally
    Applications.Free;
    Registry.Free;
  end;
end;

end.
